/* * (C) Copyright IBM Corporation 2011. */
/*
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA


 Author: IBM Corporation
 This module is part of the IBM (R) Rational (R) ClearCase (R)
 Multi-version file system (MVFS).
 For support, please visit http://www.ibm.com/software/support

*/
#ifndef MVFS_ATOMIC_DEFS_H_
#define MVFS_ATOMIC_DEFS_H_


#define ATOMIC_CAS_UINT32(addr, cmpval, newval) \
    ((atomic_cmpxchg((addr), (cmpval), (newval)) == (cmpval)) ? 1 : 0)
#define ATOMIC_CAS_PTR(addr, cmp_addr, new_addr) \
    ((cmpxchg((addr), (void *)(cmp_addr), (void *)(new_addr)) == (cmp_addr)) ? 1 : 0)
#define ATOMIC_CAS_ULONG(addr, cmpval, newval) NOTIMPLEMENTED()
#define ATOMIC_INCR_UINT32(addr)  atomic_inc(addr)
#define ATOMIC_DECR_UINT32(addr)  atomic_dec(addr)

#define ATOMIC_SET(addr, val)     atomic_set((addr), (val))
#define ATOMIC_READ(addr)         atomic_read(addr)
#define ATOMIC_PTR_READ(ADDR)     (*((typeof(*(ADDR)) *)(ADDR)))
#define ATOMIC_PTR_SET(ADDR, VAL) ((*((volatile typeof(*(ADDR)) *)(ADDR))) = (VAL))


/* Default implementation for atomic operations*/
#ifndef ATOMIC_SET
#define ATOMIC_SET(addr, val)           (*(addr) = (val))
#endif
#ifndef ATOMIC_READ
#define ATOMIC_READ(addr)               (*(addr))
#endif
#ifndef ATOMIC_PTR_READ
#define ATOMIC_PTR_READ(ADDR)           (*(ADDR))
#endif
#ifndef ATOMIC_PTR_SET
#define ATOMIC_PTR_SET(ADDR, VAL)       (*(ADDR) = (VAL))
#endif

#endif /* MVFS_ATOMIC_DEFS_H_ */
/* $Id: 742ea539.a3c211e1.8593.00:11:25:27:c4:b4 $ */
